#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

/*constantes booleennes*/
#define OUI 1
#define NON 0
#define NOT_DEFINED -1.0

/*constantes des types de donnees*/
#define COORDONNEES 0
#define ALIGNEMENT 1
#define DISTANCES 2
#define SIMILARITES 3

/*constantes des programmes de clustering*/
#define MIXTURE_MODEL 0
#define BIONJ 1
#define WARD 2
#define KMEANS 3
#define NORMALIZED_CUT 4

/*constantes des criteres de selection du nombre de groupe*/
#define DPC 0
#define SECATOR 1
#define GRAPHPC 2
#define FIXED 3

/*constantes de DPC*/
#define DENSITE1 0
#define DENSITE2 1

/*constantes de types de fichiers*/
#define FICHIER_TFA 0
#define FICHIER_MSF 1
#define FICHIER_INCONNU 2

/*constantes liees a la gestion de la memoire*/
#define TAILLE_NOM 200
#define TAILLE_POUBELLE 200
#define TAILLE_MAX_LIGNE 10000

/*constantes de calcul*/
#define ZERO_LIMIT 0.000001
#define VALEUR_ENORME 999999999999.0

/*constantes diverses*/
#define AUCUN_GROUPE -1

typedef struct t_individu {
  int id;
  char *nom;
  double *valeurs_brutes;
  double *valeurs_traitees;
  int nb_individus_similaires;
  int cluster;
  struct t_individu **individus_similaires;}t_individu;

/*type d'un noeud de l'arbre phylogenetique*/
typedef struct t_noeud{
  int numero;
  int groupe;
  int qualite;
  char etiquette[TAILLE_NOM];
  double poids;
  double dissimilarite;
  double distance;
  double distances[3]; /*en particulier, distances[0] est la distance au noeud superieur*/
  /*                     quand l'arbre est roote*/
  struct t_noeud *copain1;
  struct t_noeud *copain2;
  struct t_noeud *copains[3]; /*en particulier, copains[0] est le pere du noeud*/
  /*                            quand l'arbre est roote*/
  int secable;
  t_individu *individu;
}t_noeud;

typedef struct t_groupe {
  int nb_individus;
  t_individu **individus;
  int insecable;
  struct t_groupe *precedent;
  struct t_groupe *suivant;
  struct t_groupe *fils1;
  struct t_groupe *fils2;
  struct t_groupe *pere;
  int qualite;}t_groupe;

typedef struct couple {
  int i;
  int j;}t_couple;
